-- macro:
-- /run ShamanMount:M(GetRunningMacro(),"ground_mount_name","flying_mount_name")
-- /click ShamanMount

ShamanMountData = {["MacroName"]=nil,["GroundMountName"]=nil,["FlyingMountName"]=nil}
local GhostWolfMacro = "/cast ghost wolf"
local WalterWalkingMacro = "/cast [@player]water walking\n"

local f=CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")

local MN,GMN,FMN

function f:M(MN,GMN,FMN)
  ShamanMountData["MacroName"]=GetMacroInfo(MN)
  ShamanMountData["GroundMountName"]=GMN
  ShamanMountData["FlyingMountName"]=FMN
  if not ShamanMountData["FlyingMountName"] then ShamanMountData["FlyingMountName"]=ShamanMountData["GroundMountName"] end
  if InCombatLockdown() then
    return
  elseif not IsMounted() and IsUsableSpell(ShamanMountData["FlyingMountName"]) and GetUnitSpeed("player")==0 then
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext","/cast "..ShamanMountData["FlyingMountName"])
  elseif not IsMounted() and IsUsableSpell(ShamanMountData["GroundMountName"]) and GetUnitSpeed("player")==0 then
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["GroundMountName"])
  elseif not IsMounted() then
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext",GhostWolfMacro)
  else
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext","/dismount [noflying]")
  end
end

f:SetScript("OnEvent",function(self,event)
  if event=="PLAYER_REGEN_DISABLED" then
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext",GhostWolfMacro)
  elseif event=="SPELL_UPDATE_USABLE" or event=="ACTIONBAR_SLOT_CHANGED" or event=="PLAYER_LOGIN" then    
    if not InCombatLockdown() and IsUsableSpell(ShamanMountData["FlyingMountName"]) then
      SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["FlyingMountName"])
    elseif not InCombatLockdown() and IsUsableSpell(ShamanMountData["GroundMountName"]) then
      SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["GroundMountName"])
    else
      SetMacroSpell(ShamanMountData["MacroName"],"ghost wolf")
    end
  end
end)
f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("SPELL_UPDATE_USABLE")
f:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
f:RegisterEvent("PLAYER_LOGIN")